'use strict';

/**
 * @file   build
 * @author yucong02
 */
var webpack = require('webpack');
var fs = require('fs-extra');
var oFs = require('fs');
var nps = require('path');

function build(_ref, cb) {
    var config = _ref.config,
        src = _ref.src,
        dest = _ref.dest,
        _ref$isBuf = _ref.isBuf,
        isBuf = _ref$isBuf === undefined ? true : _ref$isBuf,
        _ref$compile = _ref.compile,
        compile = _ref$compile === undefined ? true : _ref$compile;

    if (!cb) cb = function cb() {};

    if (isBuf) {
        oFs.writeFileSync(dest, src);
    } else {
        fs.ensureDirSync(dest);
        if (oFs.statSync(src).isDirectory()) {
            fs.copySync(src, dest);
        } else {
            fs.copySync(src, nps.join(dest, nps.basename(src)));
        }
    }

    if (compile) {
        var compiler = webpack(config);
        compiler.run(cb);
    } else {
        cb();
    }
}

module.exports = build;