'use strict';

/**
 * Created by moyu on 2017/7/30.
 */
var nps = require('path');
var fsExtra = require('fs-extra');
var fs = require('fs');
var _ = require('lodash');

var tpl = _.template(fs.readFileSync(nps.join(__dirname, '../template/entry.js')).toString());

function EntryHandler(root) {
    this._dir = nps.join(root, '.entry');
    this._tpl = tpl;
}
EntryHandler.prototype.push = function (name, path, requires) {
    var file = nps.join(this._dir, name);
    if (fs.existsSync(file)) {
        return file;
    }
    fs.writeFileSync(file, this._tpl({ path: path, requires: requires }));
    return file;
};

EntryHandler.prototype.init = function () {
    if (!fs.existsSync(this._dir)) {
        fsExtra.mkdirSync(this._dir);
    }
    return this;
};

EntryHandler.prototype.exit = function () {
    fsExtra.removeSync(this._dir);
    return this;
};

module.exports = EntryHandler;