'use strict';

/**
 * @file: require
 * @author: Cuttle Cong
 * @date: 2017/12/29
 * @description: 
 */

var Module = require('module');
var resolve = require('resolve');
var nps = require('path');
var _resolveFilename = Module._resolveFilename;

module.exports = {
  over: function over(paths) {
    if (_resolveFilename !== Module._resolveFilename) {
      return;
    }

    paths = paths || [process.cwd()];
    paths.push(nps.join(__dirname, '../..'));
    Module._resolveFilename = function (request, parent, isMain, options) {
      if (resolve.isCore(request)) {
        return _resolveFilename.apply(this, arguments);
      }
      var dirname = nps.dirname(parent.filename);
      try {
        return resolve.sync(request, { basedir: dirname });
      } catch (ex) {
        var path = void 0;
        var isFound = paths.some(function (dirname) {
          try {
            path = resolve.sync(request, { basedir: dirname });
            return true;
          } catch (ex) {}
        });
        if (isFound) {
          return path;
        }
        return _resolveFilename.apply(this, arguments);
      }
    };
  },
  unover: function unover() {
    Module._resolveFilename = _resolveFilename;
  }
};