'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Created by moyu on 2017/7/30.
 */
var nps = require('path');
var _ = require('lodash');
var fs = require('fs');
var cheerio = require('cheerio');

var setupWebpackMiddleware = require('../setup-webpack-middleware');
var encodeSep = require('../encode-decode').encode;

var tplStr = fs.readFileSync(nps.join(__dirname, '../../template/tpl.html')).toString();
var renderTpl = _.template(tplStr);

module.exports = function (req, res, next) {
    var path = nps.join(req.app.locals.opts.path, req.path);
    if (/^\/(__gojs\/)|(.entry)|(.dist)/.test(req.path) || /\.jsx?\.bundle\.jsx?$/.test(req.path)) {
        next();
        return;
    }
    if (fs.existsSync(path)) {
        var addEntry = function addEntry(entryPath) {
            var singleEntry = null;
            if (singleEntry = configAdaptor.addEntry(encodeName, entryPath)) {
                setupWebpackMiddleware(req.app, _defineProperty({}, encodeName, singleEntry), configAdaptor.getConfig());
            }
        };

        var entryHandler = req.app.locals.entryHandler;
        var configAdaptor = req.app.locals.configAdaptor;
        res.contentType('html');
        var name = req.path.replace(/^\//g, '');
        var encodeName = encodeSep(name);

        var patternHtmlPath = path.replace(/\.[^\.]*$/, '.html');
        if (fs.existsSync(patternHtmlPath)) {
            addEntry(entryHandler.push(encodeName, '../' + name, ['../' + name.replace(/\.[^\.]*$/, '.html')]));
            fs.readFile(patternHtmlPath, 'utf-8', function (err, data) {
                if (err) next(err);else {
                    var $ = cheerio.load(data, { decodeEntities: false });
                    $('body').append('<script src="/__gojs/bundle/' + encodeName + '.bundle.js"></script>');
                    res.send($.html());
                }
            });
        } else {
            addEntry(entryHandler.push(encodeName, '../' + name));
            res.send(renderTpl({
                name: name,
                encodeName: encodeName
            }));
        }
    } else {
        var err = new Error('File not found: ' + path);
        err.code = 'ENOENT';
        next(err);
    }
};