'use strict';

/**
 * Created by moyu on 2017/7/30.
 */

var webpack = require('webpack');
var _ = require('lodash');
var webpackHotM = require('webpack-hot-middleware');
var webpackDevM = require('webpack-dev-middleware');

var ed = require('./encode-decode');
var log = require('./log');
var getPlugins = require('./get-webpack-plugins');

function setupWebpackMiddleware(app, entry, config) {
    // if (app.locals.num == null) {
    //     app.locals.num = -1
    // }
    // app.locals.num++

    var verbose = !!app.locals.opts.verbose;

    config = _.cloneDeep(config);

    config.plugins = getPlugins({ dev: true, config: config });

    var hmrPath = '/__webpack_hmr_' + id++;
    config.entry = _.cloneDeep(entry);
    for (var name in config.entry) {
        if (config.entry.hasOwnProperty(name)) {
            config.entry[name] = config.entry[name].map(function (x) {
                if (x.trim().startsWith('webpack-hot-middleware')) {
                    if (x.indexOf('?') >= 0) {
                        x += '&path=' + hmrPath;
                    } else {
                        x += '?path=' + hmrPath;
                    }
                }
                return x;
            });
        }
    }

    var compiler = webpack(config);
    app.use(maybeNotBundle(entry, webpackDevM(compiler, {
        noInfo: !verbose,
        stats: {
            chunks: false,
            hash: false,
            colors: { level: 2, hasBasic: true, has256: true, has16m: false }
        },
        publicPath: config.output.publicPath,
        hot: true,
        quiet: !verbose,
        log: verbose && log.info
    })));

    app.use(webpackHotM(compiler, {
        log: verbose && log.info,
        path: hmrPath
    }));
}

var id = 0;

function nextBetter(iid, fn) {
    return function (req, res, next) {
        if (iid === id) {
            fn(req, res, next);
        } else {
            next();
        }
    };
}

function maybeNotBundle(entry, fn) {
    // entry = _.cloneDeep(entry)

    // entry is unique，don't need to filter request by self
    return fn;
    /*return (req, res, next) => {
        const path = req.path
        if (path.startsWith('/__gojs/bundle/') && path.endsWith('.bundle.js')) {
            const allEntry = req.app.locals.configAdaptor.getConfig().entry
            let name = path.replace(/^\/?__gojs\/bundle\//, '').replace(/\.bundle\.js$/, '')
            let encodeName = ed.encode(name)
            if (entry[encodeName] && allEntry[encodeName]) {
                fn(req, res, next)
            } else {
                next()
            }
        } else {
            fn(req, res, next)
        }
    }*/
}

module.exports = setupWebpackMiddleware;